function NotificationEntityChanged(data) {
    this.__observers = [];
}

NotificationEntityChanged.prototype.notifyChange = function() {
    let observers = this.__observers;
    observers.forEach(o => { if (o.update && typeof o.update === 'function') { o.update(this) } });
};

NotificationEntityChanged.prototype.addObserver = function (observer) {
    if (!this.__observers.includes(observer)) {
        this.__observers.push(observer)
    }
};

NotificationEntityChanged.prototype.removeObserver = function (observer) {
    if (!this.__observers.includes(observer)) {
        this.__observers.slice(this.__observers.indexOf(observer), 1);
    }
};


NotificationEntityChanged.prototype.getObserver = function (index) {
    if (index > -1 && index < this.__observers.length) {
        return this.__observers[index];
    }
};