<?php

namespace App\Repository;

use App\Entity\PendingEditorInvitation;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Persistence\ManagerRegistry;

/**
 * @method PendingEditorInvitation|null find($id, $lockMode = null, $lockVersion = null)
 * @method PendingEditorInvitation|null findOneBy(array $criteria, array $orderBy = null)
 * @method PendingEditorInvitation[]    findAll()
 * @method PendingEditorInvitation[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class PendingEditorInvitationRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, PendingEditorInvitation::class);
    }

    /**
     * @return array<string>
     */
    public function getPendingEditorsEmails(int $capsule_id): array
    {
        $editors_emails_result = $this->createQueryBuilder('c')
            ->select('c.email')
            ->andWhere('c.capsule_id = :val')
            ->setParameter('val', $capsule_id)
            ->getQuery()
            ->getResult()
        ;

        $editors_emails = [];

        foreach ($editors_emails_result as $editor_email_result) {
            $editors_emails[] = $editor_email_result['email'];
        }

        return $editors_emails;
    }

    /**
     * @return array<PendingEditorInvitation>
     */
    public function getInvitationByCapsule(int $capsule_id): array
    {
        $query = $this->createQueryBuilder('i')
            ->where("i.capsuleId like :capId")
            ->setParameter("capId", $capsule_id)
            ->getQuery();
        return $query->getArrayResult();
    }

    // /**
    //  * @return PendingEditorInvitation[] Returns an array of PendingEditorInvitation objects
    //  */
    /*
    public function findByExampleField($value)
    {
        return $this->createQueryBuilder('p')
            ->andWhere('p.exampleField = :val')
            ->setParameter('val', $value)
            ->orderBy('p.id', 'ASC')
            ->setMaxResults(10)
            ->getQuery()
            ->getResult()
        ;
    }
    */

    /*
    public function findOneBySomeField($value): ?PendingEditorInvitation
    {
        return $this->createQueryBuilder('p')
            ->andWhere('p.exampleField = :val')
            ->setParameter('val', $value)
            ->getQuery()
            ->getOneOrNullResult()
        ;
    }
    */
}
